#! /bin/sh 
#
# Copyright (c) 2002-2003 Indiana University.  All rights reserved.
# Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
#                         All rights reserved.
# 
# This file is part of the OOMPI software package.  For license
# information, see the LICENSE file in the top level directory of the
# OOMPI source distribution.
#
# $Id: autogen.sh,v 1.4 2003/09/03 16:34:32 jsquyres Exp $
#
# This script is run on developer copies of OOMPI -- *not*
# distribution tarballs.
#

config_dir=.

#
# Some helper functions
#

test_for_existence() {
    prog="$1"
    foo="`$prog --version`"
    if test "$?" != 0; then
	cat <<EOF

You must have GNU autoconf, automake, and libtool installed to build
the developer's version of OOMPI.  You can obtain these packages
from ftp://ftp.gnu.org/gnu/.

EOF
# Stupid emacs: '
	exit 1
    fi
}

run_and_check() {
    progs="$*"
    echo "$progs"
    eval $progs
    if test "$?" != 0; then
	cat <<EOF

It seems that the execution of "$progs" has failed.
I am gonna abort.  :-(

This may be caused by an older version of one of the required
packages.  Please make sure you are using at least the following
versions:

GNU Autoconf 2.52
GNU Automake 1.5
GNU Libtool  1.4

EOF
	exit 1
    fi
}

#
# Are we in the right dir?
#

if test -f VERSION -a -f configure.in ; then
    bad=0
else
    cat <<EOF

You must run this script from the top-level OOMPI directory.

EOF
    exit 1
fi

test_for_existence autoconf
test_for_existence automake
test_for_existence libtool

#
# Run them all
#

rm -f $config_dir/config.guess
rm -f $config_dir/config.sub
rm -f $config_dir/depcomp
rm -f $config_dir/install-sh
rm -f $config_dir/ltconfig
rm -f $config_dir/ltmain.sh
rm -f $config_dir/missing
rm -f $config_dir/mkinstalldirs

run_and_check aclocal
run_and_check autoheader
run_and_check autoconf
run_and_check automake -a --copy --foreign

exit 0
