dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: cxx_check_type.m4,v 1.2 2003/02/13 21:07:46 jsquyres Exp $
dnl

define(OOMPI_CHECK_TYPE,[
#
# $1: type to check
# $2: "safe" version of type that we can use in AC_DEFINE (etc.)
# $3: extra include args
# $4: initializer value
#
# Autoconfs AC_CHECK_TYPE is not sufficient
# This, too, is not foolproof, but will have to do...
AC_MSG_CHECKING(for type $1)
CXXFLAGS_SAVE="$CXXFLAGS"
CXXFLAGS="-g"
AC_TRY_COMPILE([#include "confdefs.h"
#include <sys/types.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <stddef.h>
#endif
$3], [$1 local_var($4);], 
    oompi_result=yes oompi_found=1, 
    oompi_result=no oompi_found=0)
CXXFLAGS="$CXXFLAGS_SAVE"

AC_DEFINE_UNQUOTED(OOMPI_HAVE_$2, $oompi_found, 
    [Whether we have $1 or not])
AC_MSG_RESULT([$oompi_result])
unset oompi_found oompi_result CXXFLAGS_SAVE])dnl
