dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: mpi_check_link.m4,v 1.3 2003/02/13 21:07:46 jsquyres Exp $
dnl

define([LSC_MPI_CHECK_LINK],[
#
# Try to link a simple program, see if we can link to MPI symbols
# Use AC_TRY_LINK because we need to get <mpi.h> in order to extern
# "C" MPI functions properly (we don't want to force the use of a C
# compiler since the C++ compiler has already been setup).
# 
LIBS_save="$LIBS"
AC_MSG_CHECKING([for MPI_Initialized])
AC_TRY_LINK(#include <mpi.h>
, int i; MPI_Initialized(&i);, libmpi_found=yes, libmpi_found=no)
if test "$libmpi_found" = "no"; then
    AC_MSG_RESULT([not found -- try with -lmpi])

    LIBS="$LIBS -lmpi"
    EXTRA_LDFLAGS="-lmpi"
    AC_MSG_CHECKING([for MPI_Initialized with -lmpi])
    AC_TRY_LINK(#include <mpi.h>
, int i; MPI_Initialized(&i);, libmpi_found=yes, libmpi_found=no)
fi

if test "$libmpi_found" = "yes"; then
    AC_MSG_RESULT([found])
else
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([cannot link MPI programs -- cannot continue])
fi
LIBS="$LIBS_save"
unset LIBS_save])dnl

