dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: os_check_signal_type.m4,v 1.2 2003/02/13 21:07:46 jsquyres Exp $
dnl

define([LSC_OS_CHECK_SIGNAL_TYPE],[
#
# Do we have BSD or SYSV style signals?
# (or something that we haven't thought of yet?)
#
# Sets LSC_OS_SIGNAL_TYPE to BSD, SYSV, or aborts if it can't figure it out
#

SAVE_CXXFLAGS="$CXXFLAGS"
CXXFLAGS="$SIGNAL_FLAGS $CXXFLAGS"

AC_LANG_SAVE
AC_LANG_CPLUSPLUS

AC_MSG_CHECKING([for signal declaration])
AC_TRY_COMPILE(#include<signal.h>
extern "C" void bsd_handler(int sig, int code, struct sigcontext *scp, char *addr);
, 
signal(1, bsd_handler);, bsd_signal="yes", bsd_signal="no")
if test "$bsd_signal" = "yes"; then
    LSC_OS_SIGNAL_TYPE="BSD"
    AC_MSG_RESULT([BSD])
else

#
# Sanity check.  Make sure that it is SYSV
#

    AC_TRY_COMPILE(#include<signal.h>
extern "C" void sysv_handler(int sig);
, 
signal(1, sysv_handler);, sysv_signal="yes", sysv_signal="no")
    if test "$sysv_signal" = "yes"; then
	LSC_OS_SIGNAL_TYPE="SYSV"
        AC_MSG_RESULT([SYSV])
    else
        AC_MSG_RESULT([not found])
        AC_MSG_ERROR([cannot determine if signals are BSD/SYSV])
        exit
    fi
fi
CXXFLAGS="$SAVE_CXXFLAGS"
AC_LANG_RESTORE])dnl
