// -*- c++ -*-
//
// Copyright (c) 2002-2003 Indiana University.  All rights reserved.
// Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
//                         All rights reserved.
// 
// This file is part of the OOMPI software package.  For license
// information, see the LICENSE file in the top level directory of the
// OOMPI source distribution.
//
// $Id: ring2.cc,v 1.5 2003/03/03 21:57:00 jewillco Exp $
//
// This program is like ring1.cc except that communication is do
// explicitly through OOMPI_Ports instead of implicitly through
// communicators and the bracket operator.  The second change is that the
// message passing is expressed using the stream interface.


#include <iostream>
#include "oompi.h"

using namespace std;

int
main(int argc, char *argv[])
{
  int count = 5;
  int msg = 123;
  OOMPI_COMM_WORLD.Init(argc, argv);
  
  int rank = OOMPI_COMM_WORLD.Rank();
  int size = OOMPI_COMM_WORLD.Size();
  OOMPI_Port to   = OOMPI_COMM_WORLD[(rank + 1) % size];
  OOMPI_Port from = OOMPI_COMM_WORLD[(size + rank - 1) % size];
  
  cout << "I am node " << rank << " of " << size << endl;
  cout << "Sending to " << to.Rank() << 
    " and receiving from " << from.Rank() << endl;
  
  if (rank == size - 1)
    to << msg;
  
  for (int i = 0; i < count; i++) {
    from >> msg;
    cout << "Node " << rank << " received " << msg << endl;
    to << msg;
  }
  
  if (rank == 0) {
    from >> msg;
    cout << "Node " << rank << " received " << msg << endl;
  }
    
  cout << "All done!" << endl;
  OOMPI_COMM_WORLD.Finalize();
  
  return 0;
}
