// -*- c++ -*-
//
// Copyright (c) 2002-2003 Indiana University.  All rights reserved.
// Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
//                         All rights reserved.
// 
// This file is part of the OOMPI software package.  For license
// information, see the LICENSE file in the top level directory of the
// OOMPI source distribution.
//
// $Id: stack.cc,v 1.4 2003/02/13 21:07:48 jsquyres Exp $
//
// OOMPI Test program
// Simple stack implementation
//

#include "oompi.h"
#include "oompi_test.h"


//
// Primitive stack implementation
//

struct Stack {
  const char* msg;
  Stack* prev;
  Stack* next;
};
  

//
// Global vars for below
//

static Stack *root = 0;


//
// Push
//
void
Push(const char* msg)
{
  if (msg == 0)
    return;

  Stack *cur = new Stack;
  cur->msg = msg;
  cur->next = 0;
  cur->prev = root;

  root= cur;
}


//
// Pop
//
char*
Pop()
{
  Stack *cur = root;
  char *msg = 0;

  if (root != 0) {
    msg = (char*) root->msg;
    root = root->prev;
    delete cur;
  }

  return msg;
}
